/*
 * GestureComposer.cpp
 *
 *  Created on: Apr 29, 2015
 *      Author: fezoo
 *
 *  Modified on: May 15, 2016
 *      Author: Arantxa Casanova
 */


#include <GestureComposer.hpp>

#include <list>

#define OUTPUT_BUFFER_SIZE 1024

/////////////////////// GESTURE COMPOSER /////////////////////////

GestureComposer::GestureComposer(const std::string &ip,  int port)
{


	_tracker.tracking_score(2);

/
	_processing_period_ms=20;
	_last_received=0;
	std::cout << "Composer created" << std::endl;
}

GestureComposer::~GestureComposer()
{
	delete toRenderSocket;
}


void GestureComposer::update()
{
	_check_redundant_candidates();
	_check_redundant_candidates_pres();

		std::deque<gestoos::tracking::ObjectTrack> cand;
	{
		boost::mutex::scoped_lock scoped_lock(mutex);

		cand.resize(candidates.size());
			std::copy(candidates.begin(), candidates.end(), cand.begin());
			candidates.clear();

	}


		for( auto it=cand.begin(); it!=cand.end(); ++it)
		{
			if (it->get_score() > 5.0)
				std::cout<<"[candidate"<<it->get_id()<<"] "<<it->get_pt_world() << std::endl;
				//std::cout<<it->print() << std::endl;
			if (_tracker.active_tracks().empty()){
				std::cout << "New tracked added!!!!"<<std::endl;
				_tracker.init_at_coordinates( it->get_pt_world(), _merge_radius, gestoos::clock_ts().total_milliseconds());
			}
		}
if (!cand.empty()){
	_tracker.track( cand,  gestoos::clock_ts().total_milliseconds() );
		std::cout <<"Active tracks: "<< _tracker.active_tracks().size()<< "Candidates " << cand.size()<<std::endl;

}



if( !_tracker.active_tracks().empty() ) {
	cv::Point3f pt_xyz = _tracker.active_tracks()[0]->get_pt_world() ; //in coordinates UVZ (wall)

			cv::Point3f pt_uvz=pt_xyz;

			cv::Point3f send_pt;
			send_pt.x = pt_uvz.x ;
			send_pt.y = pt_uvz.y ;
			send_pt.z = pt_uvz.z ;
			if (detections.size()==0){
				std::size_t id = _tracker.active_tracks()[0]->get_id();

							//	std::cout << "Tracker has decided to take into account candidate "<< id << " with point "<< pt_uvz.x << " " << pt_uvz.y<< " "<< pt_uvz.z<<std::endl;
								detections.push_back(cv::Point3f(pt_uvz.x,pt_uvz.y,pt_uvz.z));
							//	cloud->push_back(pcl::PointXYZ(pt_uvz.x,pt_uvz.y,pt_uvz.z));
							//	cout << "detections size"<<detections.size()<<std::endl;
			}else {
			if (detections[detections.size()-1]!=send_pt){
				std::cout<<detections[detections.size()-1].x<<" " <<detections[detections.size()-1].y<<" "<<detections[detections.size()-1].z<<std::endl;


				std::size_t id = _tracker.active_tracks()[0]->get_id();

				//std::cout << "Tracker has decided to take into account candidate "<< id << "(score "<<_tracker.active_tracks()[0]->get_score()<< ") with point "<< pt_uvz.x << " " << pt_uvz.y<< " "<< pt_uvz.z<<std::endl;
				detections.push_back(cv::Point3f(pt_uvz.x,pt_uvz.y,pt_uvz.z));
				for (int i=0;candidates_d.size();i++){
					if (pt_uvz.x==candidates_d[i].x && pt_uvz.y==candidates_d[i].y && pt_uvz.z==candidates_d[i].z){
						stored_clients.push_back(clients[i]);
						if(candidates_d.size()>5){
							candidates_d.clear();
							clients.clear();
						}
					break;
					}
						else {
							stored_clients.push_back(clients[0]);
						}
				}
				//cout << "detections size"<<detections.size()<<std::endl;
			}
			}
	}

}


void GestureComposer::send_hand_positions()
{

	if( _tracker.active_tracks().empty() ) return;


	cv::Point3f pt_xyz = _tracker.active_tracks()[0]->get_pt_world() ; //in coordinates UVZ (wall)

		cv::Point3f pt_uvz=pt_xyz;

		cv::Point3f send_pt;
		send_pt.x = pt_uvz.x ;
		send_pt.y = pt_uvz.y ;
		send_pt.z = pt_uvz.z ;


			std::size_t id = _tracker.active_tracks()[0]->get_id();

			std::cout << "Tracker has decided to take into account candidate "<< id << " with point "<< pt_uvz.x << " " << pt_uvz.y<< " "<< pt_uvz.z<<std::endl;
			detections.push_back(cv::Point3f(pt_uvz.x,pt_uvz.y,pt_uvz.z));
			std::cout << "detections size"<<detections.size()<<std::endl;

}



void GestureComposer::send_presence_positions()
{
	std::deque<cv::Point3f> cand_pres;
	{
		boost::mutex::scoped_lock scoped_lock(mutex_pres);
		cand_pres.resize(candidates_pres.size());
		std::copy(candidates_pres.begin(), candidates_pres.end(), cand_pres.begin());
		candidates_pres.clear();
	}

	if( cand_pres.empty() ) return;

	char buffer[OUTPUT_BUFFER_SIZE];
	osc::OutboundPacketStream p( buffer, OUTPUT_BUFFER_SIZE );

	for( std::size_t i = 0; i < cand_pres.size(); ++i)
	{
		//cv::Point3f pt_xyz = cand_pres[i] ; //in coordinates UVZ (wall)

		cv::Point3f pt_uvz = cand_pres[i];

		cv::Point3f send_pt;
		send_pt.x = pt_uvz.x ;
		send_pt.y = pt_uvz.y ;
		send_pt.z = pt_uvz.z ;

		p << osc::BeginMessage( "/Wall/Proximity/Move" ) << 0 << (osc::int32)send_pt.x << (osc::int32)send_pt.y << (float)send_pt.z << osc::EndMessage;
		toRenderSocket->Send( p.Data(), p.Size() );
		p.Clear();	
	}

}


void GestureComposer::_check_redundant_candidates()
{
	{
		boost::mutex::scoped_lock scoped_lock(mutex);


		std::set<int> to_delete;

		for (int i =0; i < (int)candidates.size(); ++i)
		{
			for (int j =i+1; j < (int)candidates.size(); ++j)
			{
				double score = candidates[i] .match_world(candidates[j]);
				//std::cout<<"Match score "<<i<<"-"<<j<<"  :  "<<score<<"\n"<<std::flush;
				if (score > 0.5 )
				{
					//Erase older candidate
					if( candidates[i].get_score() > candidates[j].get_score() )
					{
						//std::cout<<"Match score "<<i<<"-"<<j<<"  :  "<<score<<"\n"<<std::flush;
						//	std::cout<<"Match ts    "<<i<<"-"<<j<<"  :  "<<candidates[i].timestamps().back()<<" : "<<candidates[j].timestamps().back()<<"\n"<<std::flush;
						to_delete.insert(j);
					}
					else
					{
						//	std::cout<<"Match score "<<i<<"-"<<j<<"  :  "<<score<<"\n"<<std::flush;
						to_delete.insert(i);
					}
				}
			}
		}

		if (to_delete.size())
		{
			for (auto it = to_delete.rbegin(); it !=to_delete.rend(); ++it)
			{
				candidates.erase(candidates.begin()+*it);
			}

		}

	}

}




void GestureComposer::_check_redundant_candidates_pres()
{
	//std::cout << "check redundant candidates pres" << std::endl;
	{
		const int PRES_DIST_THR = 200;
		boost::mutex::scoped_lock scoped_lock(mutex_pres);


		std::set<int> to_delete;
		std::vector<cv::Point3f> new_cand_pres;

		for (int i =0; i < (int)candidates_pres.size(); ++i)
		{
			for (int j =i+1; j < (int)candidates_pres.size(); ++j)
			{
				double dist = cv::norm(cv::Mat(candidates_pres[i]),cv::Mat(candidates_pres[j]));
				//std::cout<<"Match score "<<i<<"-"<<j<<"  :  "<<score<<"\n"<<std::flush;
				if (dist < PRES_DIST_THR )
				{
					//Compute mean point
					cv::Point3f mean_point = cv::Point3f(	(candidates_pres[i].x + candidates_pres[j].x) / 2.0,
							(candidates_pres[i].y + candidates_pres[j].y) / 2.0,
							(candidates_pres[i].z + candidates_pres[j].z) / 2.0 );
					new_cand_pres.push_back(mean_point);

					// Erase older candidates
					to_delete.insert(i);
					to_delete.insert(j);
				}
			}
		}

		if (to_delete.size())
		{
			for (auto it = to_delete.rbegin(); it !=to_delete.rend(); ++it)
			{
				candidates_pres.erase(candidates_pres.begin()+*it);
			}

		}

		// Add previously computed mean points from redundant presence candidates
		candidates_pres.insert(candidates_pres.end(), new_cand_pres.begin(), new_cand_pres.end());

	}

}

bool GestureComposer::_check_synchronous_receive()
{
	gestoos::Timestamp diff = gestoos::clock_ts()-_last_received;


	double elapsed_time = diff.total_milliseconds();
std::cout << "Elapsed time "<< elapsed_time<<std::endl;
	if (elapsed_time < _processing_period_ms) return false;
	else
	{
		std::cout << "Synch!!!!!!!!!"<< std::endl;
		_last_received= gestoos::clock_ts();
		return true;

	}

	//	std::set<int> found_clients;
	//	{
	//		boost::mutex::scoped_lock scoped_lock(mutex);
	//		for (std::size_t i=0; i < candidates.size(); ++i)
	//		{
	//			found_clients.insert(candidates[i].client_id);
	//		}
	//
	//		std::cout << "[_check_synchronous_receive] Found " << found_clients.size() << " out of " << RT.size() << std::endl;
	//
	//		if (found_clients.size() == RT.size())
	//		{
	//			_last_received= gestoos::clock_ts();
	//			return true;
	//		}
	//		//TODO: Detect dropped client
	//	}
	//	return  false;
}

